#!/usr/bin/python

import sys, string

Tpl = {"@@"            : "", \
       "@NB@"          : "0", \
       "@TPL_PARAMS@"  : "", \
       "@TPL_ARGS@"    : "", \
       "@FCT_PARAMS@"  : "", \
       "@FCT_ARGS@"    : "" \
       }

Test = {"@@" : "", \
        "@NB@" : "0", \
        "@FCT_PARAMS@" : "", \
        "@FCT_CONCAT@" : "\"\"", \
        "@TPL_ARGS@" : "",
        "@FCT_ARGS_1@" : "",
        "@FCT_ARGS_2@" : "",
        "@FCT_ARGS_3@" : "",
        "@FCT_ARGS_4@" : "",
        "@FCT_ARGS_5@" : "",
        "@FCT_ARGS_6@" : "",
        "@FCT_ARGS_7@" : "",
        "@FCT_ARGS_8@" : "",
        "@FCT_ARGS_9@" : "",
        "@FCT_ARGS_10@" : "",
        "@FCT_ARGS_11@" : "",
        "@FCT_ARGS_12@" : "",
        "@FCT_ARGS_13@" : "",
        "@FCT_ARGS_14@" : "",
        "@FCT_ARGS_15@" : "",
        "@FCT_ARGS_16@" : "",
        "@FCT_ARGS_17@" : "",
        "@FCT_ARGS_18@" : "",
        "@FCT_ARGS_19@" : "",
        "@FCT_ARGS_20@" : ""
        }

slotsig_tpl = """
#ifndef __SLOTSIG_@NB@_H__
#define __SLOTSIG_@NB@_H__ 1

#include <set>
#include <functional>
#include <algorithm>

#include "slotsig_bases.h"

namespace SlotSig {

template <typename _RETURN_TYPE@@ @TPL_PARAMS@>
class Slot@NB@ : public SlotBase
{ public:
    virtual _RETURN_TYPE operator() (@FCT_PARAMS@) const = 0 ;
    virtual bool operator== (Slot@NB@<_RETURN_TYPE@@ @TPL_ARGS@>* sl) const = 0 ;
} ; // class Slot@NB@<>

template <class _C, typename _RETURN_TYPE, typename _METHOD_TYPE@@ @TPL_PARAMS@>
class SlotInClass@NB@ : public Slot@NB@<_RETURN_TYPE@@ @TPL_ARGS@>
{
  public:
    SlotInClass@NB@ (_C* c, _METHOD_TYPE m) :
      Slot@NB@<_RETURN_TYPE@@ @TPL_ARGS@>(),
      in_class(c),
      method(m)
    { }

    virtual _RETURN_TYPE operator()(@FCT_PARAMS@) const
    {
      return (in_class->*method)(@FCT_ARGS@) ;
    }

    virtual bool operator== (Slot@NB@<_RETURN_TYPE @@ @TPL_ARGS@>* sl) const
    {
      SlotInClass@NB@<_C, _RETURN_TYPE, _METHOD_TYPE@@ @TPL_ARGS@>* sic =
        dynamic_cast<SlotInClass@NB@<_C, _RETURN_TYPE, _METHOD_TYPE@@ @TPL_ARGS@>*>(sl) ;
      if ( sic == 0 )
        return 0 ;
      return ( (in_class == sic->in_class) &&
               (method == sic->method) ) ;
    }

  protected:
    _C* in_class ;
    _METHOD_TYPE method ;
} ; // class SlotInClass@NB@

template <typename _RETURN_TYPE@@ @TPL_PARAMS@>
struct equal_slot@NB@
{
  equal_slot@NB@ (Slot@NB@<_RETURN_TYPE@@ @TPL_ARGS@>* sl) :
    slot(sl)
  { }

  bool operator() (Slot@NB@<_RETURN_TYPE@@ @TPL_ARGS@>* sl)
  {
    return (*slot == sl) ;
  }

  Slot@NB@<_RETURN_TYPE@@ @TPL_ARGS@>* slot ;
} ;

template <typename _RETURN_TYPE@@ @TPL_PARAMS@>
class Sig@NB@ : public SignalBase
{
  public:
    typedef _RETURN_TYPE (*global_slot_t) (@FCT_PARAMS@) ;

    Sig@NB@() :
      SignalBase(),
      global_slots(),
      method_slots()
    { }

    ~Sig@NB@()
    {
      register const typename methods_slots_set::const_iterator end =
        method_slots.end() ;
      register typename methods_slots_set::const_iterator iter =
        method_slots.begin() ;
      while ( iter != end )
        delete *(iter++) ;
    }

    void connect (global_slot_t f)
    {
      if ( f == 0 )
        return ;
      global_slots.insert(f) ;
    }

    template <class _C>
    void connect (_C* in_class,
                  _RETURN_TYPE (_C::*method)(@TPL_ARGS@))
    {
      connectGen(in_class, method) ;
    }

    template <class _C>
    void connect (_C* in_class,
                  _RETURN_TYPE (_C::*method)(@TPL_ARGS@) const)
    {
      connectGen(in_class, method) ;
    }

    template <class _C, class _C_PARENT>
    void connect (_C* in_class,
                  _RETURN_TYPE (_C_PARENT::*methode)(@TPL_ARGS@))
    {
      _C_PARENT* parent_class = dynamic_cast<_C_PARENT*>(in_class) ;
      if ( parent_class != 0 )
        connect (parent_class, methode) ;
    }

    template <class _C, class _C_PARENT>
    void connect (_C* in_class,
                  _RETURN_TYPE (_C_PARENT::*methode)(@TPL_ARGS@) const)
    {
      _C_PARENT* parent_class = dynamic_cast<_C_PARENT*>(in_class) ;
      if ( parent_class != 0 )
        connectGen (parent_class, methode) ;
    }

    void disconnect (global_slot_t f)
    {
      global_slots.erase(f) ;
    }

    template <class _C>
    void disconnect (_C* in_class,
                     _RETURN_TYPE (_C::*methode)(@TPL_ARGS@))
    {
      disconnectGen(in_class, methode) ;
    }

    template <class _C>
    void disconnect (_C* in_class,
                     _RETURN_TYPE (_C::*methode)(@TPL_ARGS@) const)
    {
      disconnectGen(in_class, methode) ;
    }

    template <class _C, class _C_PARENT>
    void disconnect (_C* in_class,
                     _RETURN_TYPE (_C_PARENT::*methode)(@TPL_ARGS@))
    { _C_PARENT* parent_class = dynamic_cast<_C_PARENT*>(in_class) ;
      if ( parent_class != 0 )
        disconnect (parent_class, methode) ;
    }

    template <class _C, class _C_PARENT>
    void disconnect (_C* in_class,
                     _RETURN_TYPE (_C_PARENT::*methode)(@TPL_ARGS@) const)
    { _C_PARENT* parent_class = dynamic_cast<_C_PARENT*>(in_class) ;
      if ( parent_class != 0 )
        disconnectGen (parent_class, methode) ;
    }

    void emit(@FCT_PARAMS@) const
    {
      register const typename global_slots_set::const_iterator end =
        global_slots.end() ;
      register typename global_slots_set::const_iterator iter =
        global_slots.begin() ;
      while ( iter != end )
        (*(iter++))(@FCT_ARGS@) ;
      register const typename methods_slots_set::const_iterator end2 =
        method_slots.end() ;
      register typename methods_slots_set::const_iterator iter2 =
        method_slots.begin() ;
      while ( iter2 != end2 )
        (*(*(iter2++)))(@FCT_ARGS@) ;
    }

    template <class _ACCUMULATOR>
    void emit(_ACCUMULATOR& accum@@ @FCT_PARAMS@) const
    {
      register const typename global_slots_set::const_iterator end =
        global_slots.end() ;
      register typename global_slots_set::const_iterator iter =
        global_slots.begin() ;
      while ( iter != end )
        accum((*(iter++))(@FCT_ARGS@)) ;
      register const typename methods_slots_set::const_iterator end2 =
        method_slots.end() ;
      register typename methods_slots_set::const_iterator iter2 =
        method_slots.begin() ;
      while ( iter2 != end2 )
        accum((*(*(iter2++)))(@FCT_ARGS@)) ;
    }

  protected:
    virtual void disconnectSlot(SlotBase*& sl)
    {
      Slot@NB@<_RETURN_TYPE@@ @TPL_ARGS@>* slot =
        dynamic_cast<Slot@NB@<_RETURN_TYPE@@ @TPL_ARGS@>*>(sl) ;
      if ( slot == 0 )
        return ;
      method_slots.erase(slot) ;
      delete sl ;
      sl = 0 ;
    }

  private:
    template <class _C, typename _METHOD_TYPE>
    void connectGen (_C* in_class,
                     _METHOD_TYPE method)
    {
      if ( in_class == 0 )
        return ;
      SlotInClass@NB@<_C, _RETURN_TYPE, _METHOD_TYPE@@ @TPL_ARGS@>* slot =
        new SlotInClass@NB@<_C, _RETURN_TYPE, _METHOD_TYPE@@ @TPL_ARGS@>(in_class, method) ;
      typename methods_slots_set::const_iterator iter =
        std::find_if(method_slots.begin(), method_slots.end(),
          equal_slot@NB@<_RETURN_TYPE@@ @TPL_ARGS@>(slot)) ;
      if ( iter != method_slots.end() )
        delete slot ;
      else
      {
        method_slots.insert(slot) ;
        connectTo(in_class, slot) ;
      }
    }

    template <class _C, typename _METHOD_TYPE>
    void disconnectGen (_C* in_class,
                        _METHOD_TYPE method)
    {
      if ( in_class == 0 )
        return ;
      SlotInClass@NB@<_C, _RETURN_TYPE, _METHOD_TYPE@@ @TPL_ARGS@>
        slot(in_class, method) ;
      typename methods_slots_set::const_iterator iter =
        std::find_if(method_slots.begin(), method_slots.end(),
          equal_slot@NB@<_RETURN_TYPE@@ @TPL_ARGS@>(&slot)) ;
      if ( iter != method_slots.end() )
      { disconnectTo(in_class, *iter) ; }
    }

    typedef std::set<global_slot_t> global_slots_set ;
    global_slots_set global_slots ;

    typedef std::set<Slot@NB@<_RETURN_TYPE@@ @TPL_ARGS@>*> methods_slots_set ;
    methods_slots_set method_slots ;
} ; // class Sig@NB@<>

} // namespace SlotSig

#endif // __SLOTSIG_@NB@_H__
"""

test_tpl = """
#include <iostream>
#include <string>
#include "../slotsig/slotsig_@NB@.h"

class C1 : public SlotSig::SlotsSetBase
{
  public:
    C1() : SlotSig::SlotsSetBase() { }

    std::string m1(@FCT_PARAMS@)
    {
      std::string s = @FCT_CONCAT@ ;
      std::cout << "C1::m1 (" << s << ")\\n" ;
      return "C1::m1" ;
    }

    std::string m2(@FCT_PARAMS@) const
    {
      std::string s = @FCT_CONCAT@ ;
      std::cout << "C1::m2 (" << s << ")\\n" ;
      return "C1::m2" ;
    }

    virtual std::string vm1(@FCT_PARAMS@)
    {
      std::string s = @FCT_CONCAT@ ;
      std::cout << "C1::vm1 (" << s << ")\\n" ;
      return "C1::vm1" ;
    }

    virtual std::string vm2(@FCT_PARAMS@) const
    {
      std::string s = @FCT_CONCAT@ ;
      std::cout << "C1::vm2 (" << s << ")\\n" ;
      return "C1::vm2" ;
    }
} ; // C1

class C2 : public C1
{
  public:
    C2() : C1() { }

    virtual std::string vm1(@FCT_PARAMS@)
    {
      std::string s = @FCT_CONCAT@ ;
      std::cout << "C2::vm1 (" << s << ")\\n" ;
      return "C2::vm1" ;
    }

    virtual std::string vm2(@FCT_PARAMS@) const
    {
      std::string s = @FCT_CONCAT@ ;
      std::cout << "C2::vm2 (" << s << ")\\n" ;
      return "C2::vm2" ;
    }
} ; // C2

std::string global_slot(@FCT_PARAMS@)
{
  std::string s = @FCT_CONCAT@ ;
  std::cout << "::global_slot (" << s << ")\\n" ;
  return "::global_slot" ;
}

struct Accum
{
  Accum() : str("") { }

  void operator() (const std::string& s)
  { str += (s + " ") ; }

  std::string str ;
} ; // Accum

int main()
{
  std::cout << "--- Test program START ---\\n" ;

  C1* c1 = new C1 ;
  C2* c2 = new C2 ;
  typedef SlotSig::Sig@NB@<std::string@@ @TPL_ARGS@> SigType ;
  SigType* sig1 = new SigType ;
  SigType* sig2 = new SigType ;
  Accum accum ;

  std::cout << "--- Connecting all methods from c1 to sig1...\\n" ;
  sig1->connect (global_slot) ;
  sig1->connect (c1, &C1::m1) ;
  sig1->connect (c1, &C1::m2) ;
  sig1->connect (c1, &C1::vm1) ;
  sig1->connect (c1, &C1::vm2) ;
  std::cout << "--- Emitting sig1 #1...\\n" ;
  sig1->emit(@FCT_ARGS_1@) ;
  std::cout << "--- Emitting sig1 #2 with accumulator...\\n" ;
  accum.str = "" ;
  sig1->emit(accum@@ @FCT_ARGS_2@) ;
  std::cout << "accum.str = " << accum.str << "\\n" ;

  std::cout << "--- Re-connecting all methods from c1 to sig1...\\n" ;
  sig1->connect (global_slot) ;
  sig1->connect (c1, &C1::m1) ;
  sig1->connect (c1, &C1::m2) ;
  sig1->connect (c1, &C1::vm1) ;
  sig1->connect (c1, &C1::vm2) ;
  std::cout << "--- Emitting sig1 #3...\\n" ;
  sig1->emit(@FCT_ARGS_3@) ;
  std::cout << "--- Emitting sig1 #4 with accumulator...\\n" ;
  accum.str = "" ;
  sig1->emit(accum@@ @FCT_ARGS_4@) ;
  std::cout << "accum.str = " << accum.str << "\\n" ;

  std::cout << "--- Connecting all methods from c2 to sig1...\\n" ;
  sig1->connect (c2, &C2::m1) ;
  sig1->connect (c2, &C2::m2) ;
  sig1->connect (c2, &C2::vm1) ;
  sig1->connect (c2, &C2::vm2) ;
  std::cout << "--- Emitting sig1 #5...\\n" ;
  sig1->emit(@FCT_ARGS_5@) ;
  std::cout << "--- Emitting sig1 #6 with accumulator...\\n" ;
  accum.str = "" ;
  sig1->emit(accum@@ @FCT_ARGS_6@) ;
  std::cout << "accum.str = " << accum.str << "\\n" ;

  std::cout << "--- Connecting all methods from c1 and c2 to sig2...\\n" ;
  sig2->connect (global_slot) ;
  sig2->connect (c1, &C1::m1) ;
  sig2->connect (c1, &C1::m2) ;
  sig2->connect (c1, &C1::vm1) ;
  sig2->connect (c1, &C1::vm2) ;
  sig2->connect (c2, &C2::m1) ;
  sig2->connect (c2, &C2::m2) ;
  sig2->connect (c2, &C2::vm1) ;
  sig2->connect (c2, &C2::vm2) ;
  std::cout << "--- Emitting sig2 #7...\\n" ;
  sig2->emit(@FCT_ARGS_7@) ;
  std::cout << "--- Emitting sig2 #8 with accumulator...\\n" ;
  accum.str = "" ;
  sig2->emit(accum@@ @FCT_ARGS_8@) ;
  std::cout << "accum.str = " << accum.str << "\\n" ;

  std::cout << "--- Disconnecting c1->m1, c1->vm2, c2->m2 and c2->vm1 from sig2...\\n" ;
  sig2->disconnect(global_slot) ;
  sig2->disconnect(c1, &C1::m1) ;
  sig2->disconnect(c1, &C1::vm2) ;
  sig2->disconnect(c2, &C2::m2) ;
  sig2->disconnect(c2, &C2::vm1) ;
  std::cout << "--- Emitting sig1 #9...\\n" ;
  sig1->emit(@FCT_ARGS_9@) ;
  std::cout << "--- Emitting sig1 #10 with accumulator...\\n" ;
  accum.str = "" ;
  sig1->emit(accum@@ @FCT_ARGS_10@) ;
  std::cout << "accum.str = " << accum.str << "\\n" ;
  std::cout << "--- Emitting sig2 #11...\\n" ;
  sig2->emit(@FCT_ARGS_11@) ;
  std::cout << "--- Emitting sig2 #12 with accumulator...\\n" ;
  accum.str = "" ;
  sig2->emit(accum@@ @FCT_ARGS_12@) ;
  std::cout << "accum.str = " << accum.str << "\\n" ;

  std::cout << "--- Deleting c1...\\n" ;
  delete c1 ;
  c1 = 0 ;
  std::cout << "--- Emitting sig1 #13...\\n" ;
  sig1->emit(@FCT_ARGS_13@) ;
  std::cout << "--- Emitting sig1 #14 with accumulator...\\n" ;
  accum.str = "" ;
  sig1->emit(accum@@ @FCT_ARGS_14@) ;
  std::cout << "accum.str = " << accum.str << "\\n" ;
  std::cout << "--- Emitting sig2 #15...\\n" ;
  sig2->emit(@FCT_ARGS_15@) ;
  std::cout << "--- Emitting sig2 #16 with accumulator...\\n" ;
  accum.str = "" ;
  sig2->emit(accum@@ @FCT_ARGS_16@) ;
  std::cout << "accum.str = " << accum.str << "\\n" ;

  std::cout << "--- Deleting sig1...\\n" ;
  delete sig1 ;
  sig1 = 0 ;
  std::cout << "--- Emitting sig2 #17...\\n" ;
  sig2->emit(@FCT_ARGS_17@) ;
  std::cout << "--- Emitting sig2 #18 with accumulator...\\n" ;
  accum.str = "" ;
  sig2->emit(accum@@ @FCT_ARGS_18@) ;
  std::cout << "accum.str = " << accum.str << "\\n" ;

  std::cout << "--- Deleting c2...\\n" ;
  delete c2 ;
  std::cout << "--- Emitting sig2 #19...\\n" ;
  sig2->emit(@FCT_ARGS_19@) ;
  std::cout << "--- Emitting sig2 #20 with accumulator...\\n" ;
  accum.str = "" ;
  sig2->emit(accum@@ @FCT_ARGS_20@) ;
  std::cout << "accum.str = " << accum.str << "\\n" ;

  std::cout << "--- Deleting sig2...\\n" ;
  delete sig2 ;

  std::cout << "--- Test program END ----\\n" ;
  return 0 ;
}
"""

nb = int(sys.argv[1])

Tpl["@NB@"] = "%d"%nb
Test["@NB@"] = "%d"%nb
if ( nb > 0 ) :
  Tpl["@@"] = ","
  Test["@@"] = ","
  r = range(nb)
  Tpl["@TPL_PARAMS@"] = string.join(["typename _ARG%d_TYPE" % i for i in r], ", ")
  Tpl["@TPL_ARGS@"]   = string.join(["_ARG%d_TYPE" % i for i in r], ", ")
  Tpl["@FCT_PARAMS@"] = string.join(["_ARG%d_TYPE arg%d" % (i,i) for i in r], ", ")
  Tpl["@FCT_ARGS@"]   = string.join(["arg%d" % i for i in r], ", ")
  Test["@FCT_PARAMS@"] = string.join(["const std::string& s%d" % i for i in r], ", ")
  Test["@FCT_CONCAT@"] = string.join(["s%d" % i for i in r], " + \", \" + ")
  Test["@TPL_ARGS@"] = string.join(["const std::string&" for i in r], ", ")
  for id in range(1,21) :
    Test["@FCT_ARGS_%d@"%id] = string.join(["\"e%d_%d\""%(id,i) for i in r], ", ")

print "Generating SlotSig header for %d parameters into <slotsig_%d.h>..." % (nb,nb)
f_out = file("slotsig/slotsig_%d.h"%nb, 'w')
f_out.write("""
/*
 * slotsig_%d.h header file, auto-generated by %s
 *
 * Part of the SlogSig project, an attempt to provide a type-safe
 * signals/slots mechanism for the C++ language.
 * This file provides support for signals and slots using %d parameter(s)
 *
 * Copyright (C) 2003 Yves Bailly <kafka_AT_kafka-fr_DOT_net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
*/
""" % (nb, sys.argv[0], nb) )
slotsig = slotsig_tpl
for tr in Tpl.items() :
  slotsig = string.replace(slotsig, tr[0], tr[1])
f_out.write(slotsig)
f_out.close()

print "Generating test file for <slotsig_%d.h> into test_%d.cpp..." % (nb,nb)
f_out = file("tests/test_%d.cpp"%nb, 'w')
f_out.write("""
/*
 * test_%d.cpp test file, auto-generated by %s
 *
 * Part of the SlogSig project, an attempt to provide a type-safe
 * signals/slots mechanism for the C++ language.
 * This file is a test program for signals and slots using %d parameter(s)
 *
 * Copyright (C) 2003 Yves Bailly <kafka_AT_kafka-fr_DOT_net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
*/
""" % (nb, sys.argv[0], nb) )
test = test_tpl
for tr in Test.items() :
  test = string.replace(test, tr[0], tr[1])
f_out.write(test)
f_out.close()
