
/*
 * slotsig_0.h header file, auto-generated by generate_slotsig.py
 *
 * Part of the SlogSig project, an attempt to provide a type-safe
 * signals/slots mechanism for the C++ language.
 * This file provides support for signals and slots using 0 parameter(s)
 *
 * Copyright (C) 2003 Yves Bailly <kafka_AT_kafka-fr_DOT_net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
*/

#ifndef __SLOTSIG_0_H__
#define __SLOTSIG_0_H__ 1

#include <set>
#include <functional>
#include <algorithm>

#include "slotsig_bases.h"

namespace SlotSig {

template <typename _RETURN_TYPE >
class Slot0 : public SlotBase
{ public:
    virtual _RETURN_TYPE operator() () const = 0 ;
    virtual bool operator== (Slot0<_RETURN_TYPE >* sl) const = 0 ;
} ; // class Slot0<>

template <class _C, typename _RETURN_TYPE, typename _METHOD_TYPE >
class SlotInClass0 : public Slot0<_RETURN_TYPE >
{
  public:
    SlotInClass0 (_C* c, _METHOD_TYPE m) :
      Slot0<_RETURN_TYPE >(),
      in_class(c),
      method(m)
    { }

    virtual _RETURN_TYPE operator()() const
    {
      return (in_class->*method)() ;
    }

    virtual bool operator== (Slot0<_RETURN_TYPE  >* sl) const
    {
      SlotInClass0<_C, _RETURN_TYPE, _METHOD_TYPE >* sic =
        dynamic_cast<SlotInClass0<_C, _RETURN_TYPE, _METHOD_TYPE >*>(sl) ;
      if ( sic == 0 )
        return 0 ;
      return ( (in_class == sic->in_class) &&
               (method == sic->method) ) ;
    }

  protected:
    _C* in_class ;
    _METHOD_TYPE method ;
} ; // class SlotInClass0

template <typename _RETURN_TYPE >
struct equal_slot0
{
  equal_slot0 (Slot0<_RETURN_TYPE >* sl) :
    slot(sl)
  { }

  bool operator() (Slot0<_RETURN_TYPE >* sl)
  {
    return (*slot == sl) ;
  }

  Slot0<_RETURN_TYPE >* slot ;
} ;

template <typename _RETURN_TYPE >
class Sig0 : public SignalBase
{
  public:
    typedef _RETURN_TYPE (*global_slot_t) () ;

    Sig0() :
      SignalBase(),
      global_slots(),
      method_slots()
    { }

    ~Sig0()
    {
      register const typename methods_slots_set::const_iterator end =
        method_slots.end() ;
      register typename methods_slots_set::const_iterator iter =
        method_slots.begin() ;
      while ( iter != end )
        delete *(iter++) ;
    }

    void connect (global_slot_t f)
    {
      if ( f == 0 )
        return ;
      global_slots.insert(f) ;
    }

    template <class _C>
    void connect (_C* in_class,
                  _RETURN_TYPE (_C::*method)())
    {
      connectGen(in_class, method) ;
    }

    template <class _C>
    void connect (_C* in_class,
                  _RETURN_TYPE (_C::*method)() const)
    {
      connectGen(in_class, method) ;
    }

    template <class _C, class _C_PARENT>
    void connect (_C* in_class,
                  _RETURN_TYPE (_C_PARENT::*methode)())
    {
      _C_PARENT* parent_class = dynamic_cast<_C_PARENT*>(in_class) ;
      if ( parent_class != 0 )
        connect (parent_class, methode) ;
    }

    template <class _C, class _C_PARENT>
    void connect (_C* in_class,
                  _RETURN_TYPE (_C_PARENT::*methode)() const)
    {
      _C_PARENT* parent_class = dynamic_cast<_C_PARENT*>(in_class) ;
      if ( parent_class != 0 )
        connectGen (parent_class, methode) ;
    }

    void disconnect (global_slot_t f)
    {
      global_slots.erase(f) ;
    }

    template <class _C>
    void disconnect (_C* in_class,
                     _RETURN_TYPE (_C::*methode)())
    {
      disconnectGen(in_class, methode) ;
    }

    template <class _C>
    void disconnect (_C* in_class,
                     _RETURN_TYPE (_C::*methode)() const)
    {
      disconnectGen(in_class, methode) ;
    }

    template <class _C, class _C_PARENT>
    void disconnect (_C* in_class,
                     _RETURN_TYPE (_C_PARENT::*methode)())
    { _C_PARENT* parent_class = dynamic_cast<_C_PARENT*>(in_class) ;
      if ( parent_class != 0 )
        disconnect (parent_class, methode) ;
    }

    template <class _C, class _C_PARENT>
    void disconnect (_C* in_class,
                     _RETURN_TYPE (_C_PARENT::*methode)() const)
    { _C_PARENT* parent_class = dynamic_cast<_C_PARENT*>(in_class) ;
      if ( parent_class != 0 )
        disconnectGen (parent_class, methode) ;
    }

    void emit() const
    {
      register const typename global_slots_set::const_iterator end =
        global_slots.end() ;
      register typename global_slots_set::const_iterator iter =
        global_slots.begin() ;
      while ( iter != end )
        (*(iter++))() ;
      register const typename methods_slots_set::const_iterator end2 =
        method_slots.end() ;
      register typename methods_slots_set::const_iterator iter2 =
        method_slots.begin() ;
      while ( iter2 != end2 )
        (*(*(iter2++)))() ;
    }

    template <class _ACCUMULATOR>
    void emit(_ACCUMULATOR& accum ) const
    {
      register const typename global_slots_set::const_iterator end =
        global_slots.end() ;
      register typename global_slots_set::const_iterator iter =
        global_slots.begin() ;
      while ( iter != end )
        accum((*(iter++))()) ;
      register const typename methods_slots_set::const_iterator end2 =
        method_slots.end() ;
      register typename methods_slots_set::const_iterator iter2 =
        method_slots.begin() ;
      while ( iter2 != end2 )
        accum((*(*(iter2++)))()) ;
    }

  protected:
    virtual void disconnectSlot(SlotBase*& sl)
    {
      Slot0<_RETURN_TYPE >* slot =
        dynamic_cast<Slot0<_RETURN_TYPE >*>(sl) ;
      if ( slot == 0 )
        return ;
      method_slots.erase(slot) ;
      delete sl ;
      sl = 0 ;
    }

  private:
    template <class _C, typename _METHOD_TYPE>
    void connectGen (_C* in_class,
                     _METHOD_TYPE method)
    {
      if ( in_class == 0 )
        return ;
      SlotInClass0<_C, _RETURN_TYPE, _METHOD_TYPE >* slot =
        new SlotInClass0<_C, _RETURN_TYPE, _METHOD_TYPE >(in_class, method) ;
      typename methods_slots_set::const_iterator iter =
        std::find_if(method_slots.begin(), method_slots.end(),
          equal_slot0<_RETURN_TYPE >(slot)) ;
      if ( iter != method_slots.end() )
        delete slot ;
      else
      {
        method_slots.insert(slot) ;
        connectTo(in_class, slot) ;
      }
    }

    template <class _C, typename _METHOD_TYPE>
    void disconnectGen (_C* in_class,
                        _METHOD_TYPE method)
    {
      if ( in_class == 0 )
        return ;
      SlotInClass0<_C, _RETURN_TYPE, _METHOD_TYPE >
        slot(in_class, method) ;
      typename methods_slots_set::const_iterator iter =
        std::find_if(method_slots.begin(), method_slots.end(),
          equal_slot0<_RETURN_TYPE >(&slot)) ;
      if ( iter != method_slots.end() )
      { disconnectTo(in_class, *iter) ; }
    }

    typedef std::set<global_slot_t> global_slots_set ;
    global_slots_set global_slots ;

    typedef std::set<Slot0<_RETURN_TYPE >*> methods_slots_set ;
    methods_slots_set method_slots ;
} ; // class Sig0<>

} // namespace SlotSig

#endif // __SLOTSIG_0_H__
