
/*
 * test_7.cpp test file, auto-generated by generate_slotsig.py
 *
 * Part of the SlogSig project, an attempt to provide a type-safe
 * signals/slots mechanism for the C++ language.
 * This file is a test program for signals and slots using 7 parameter(s)
 *
 * Copyright (C) 2003 Yves Bailly <kafka_AT_kafka-fr_DOT_net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
*/

#include <iostream>
#include <string>
#include "../slotsig/slotsig_7.h"

class C1 : public SlotSig::SlotsSetBase
{
  public:
    C1() : SlotSig::SlotsSetBase() { }

    std::string m1(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6)
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 ;
      std::cout << "C1::m1 (" << s << ")\n" ;
      return "C1::m1" ;
    }

    std::string m2(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6) const
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 ;
      std::cout << "C1::m2 (" << s << ")\n" ;
      return "C1::m2" ;
    }

    virtual std::string vm1(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6)
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 ;
      std::cout << "C1::vm1 (" << s << ")\n" ;
      return "C1::vm1" ;
    }

    virtual std::string vm2(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6) const
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 ;
      std::cout << "C1::vm2 (" << s << ")\n" ;
      return "C1::vm2" ;
    }
} ; // C1

class C2 : public C1
{
  public:
    C2() : C1() { }

    virtual std::string vm1(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6)
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 ;
      std::cout << "C2::vm1 (" << s << ")\n" ;
      return "C2::vm1" ;
    }

    virtual std::string vm2(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6) const
    {
      std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 ;
      std::cout << "C2::vm2 (" << s << ")\n" ;
      return "C2::vm2" ;
    }
} ; // C2

std::string global_slot(const std::string& s0, const std::string& s1, const std::string& s2, const std::string& s3, const std::string& s4, const std::string& s5, const std::string& s6)
{
  std::string s = s0 + ", " + s1 + ", " + s2 + ", " + s3 + ", " + s4 + ", " + s5 + ", " + s6 ;
  std::cout << "::global_slot (" << s << ")\n" ;
  return "::global_slot" ;
}

struct Accum
{
  Accum() : str("") { }

  void operator() (const std::string& s)
  { str += (s + " ") ; }

  std::string str ;
} ; // Accum

int main()
{
  std::cout << "--- Test program START ---\n" ;

  C1* c1 = new C1 ;
  C2* c2 = new C2 ;
  typedef SlotSig::Sig7<std::string, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&, const std::string&> SigType ;
  SigType* sig1 = new SigType ;
  SigType* sig2 = new SigType ;
  Accum accum ;

  std::cout << "--- Connecting all methods from c1 to sig1...\n" ;
  sig1->connect (global_slot) ;
  sig1->connect (c1, &C1::m1) ;
  sig1->connect (c1, &C1::m2) ;
  sig1->connect (c1, &C1::vm1) ;
  sig1->connect (c1, &C1::vm2) ;
  std::cout << "--- Emitting sig1 #1...\n" ;
  sig1->emit("e1_0", "e1_1", "e1_2", "e1_3", "e1_4", "e1_5", "e1_6") ;
  std::cout << "--- Emitting sig1 #2 with accumulator...\n" ;
  accum.str = "" ;
  sig1->emit(accum, "e2_0", "e2_1", "e2_2", "e2_3", "e2_4", "e2_5", "e2_6") ;
  std::cout << "accum.str = " << accum.str << "\n" ;

  std::cout << "--- Re-connecting all methods from c1 to sig1...\n" ;
  sig1->connect (global_slot) ;
  sig1->connect (c1, &C1::m1) ;
  sig1->connect (c1, &C1::m2) ;
  sig1->connect (c1, &C1::vm1) ;
  sig1->connect (c1, &C1::vm2) ;
  std::cout << "--- Emitting sig1 #3...\n" ;
  sig1->emit("e3_0", "e3_1", "e3_2", "e3_3", "e3_4", "e3_5", "e3_6") ;
  std::cout << "--- Emitting sig1 #4 with accumulator...\n" ;
  accum.str = "" ;
  sig1->emit(accum, "e4_0", "e4_1", "e4_2", "e4_3", "e4_4", "e4_5", "e4_6") ;
  std::cout << "accum.str = " << accum.str << "\n" ;

  std::cout << "--- Connecting all methods from c2 to sig1...\n" ;
  sig1->connect (c2, &C2::m1) ;
  sig1->connect (c2, &C2::m2) ;
  sig1->connect (c2, &C2::vm1) ;
  sig1->connect (c2, &C2::vm2) ;
  std::cout << "--- Emitting sig1 #5...\n" ;
  sig1->emit("e5_0", "e5_1", "e5_2", "e5_3", "e5_4", "e5_5", "e5_6") ;
  std::cout << "--- Emitting sig1 #6 with accumulator...\n" ;
  accum.str = "" ;
  sig1->emit(accum, "e6_0", "e6_1", "e6_2", "e6_3", "e6_4", "e6_5", "e6_6") ;
  std::cout << "accum.str = " << accum.str << "\n" ;

  std::cout << "--- Connecting all methods from c1 and c2 to sig2...\n" ;
  sig2->connect (global_slot) ;
  sig2->connect (c1, &C1::m1) ;
  sig2->connect (c1, &C1::m2) ;
  sig2->connect (c1, &C1::vm1) ;
  sig2->connect (c1, &C1::vm2) ;
  sig2->connect (c2, &C2::m1) ;
  sig2->connect (c2, &C2::m2) ;
  sig2->connect (c2, &C2::vm1) ;
  sig2->connect (c2, &C2::vm2) ;
  std::cout << "--- Emitting sig2 #7...\n" ;
  sig2->emit("e7_0", "e7_1", "e7_2", "e7_3", "e7_4", "e7_5", "e7_6") ;
  std::cout << "--- Emitting sig2 #8 with accumulator...\n" ;
  accum.str = "" ;
  sig2->emit(accum, "e8_0", "e8_1", "e8_2", "e8_3", "e8_4", "e8_5", "e8_6") ;
  std::cout << "accum.str = " << accum.str << "\n" ;

  std::cout << "--- Disconnecting c1->m1, c1->vm2, c2->m2 and c2->vm1 from sig2...\n" ;
  sig2->disconnect(global_slot) ;
  sig2->disconnect(c1, &C1::m1) ;
  sig2->disconnect(c1, &C1::vm2) ;
  sig2->disconnect(c2, &C2::m2) ;
  sig2->disconnect(c2, &C2::vm1) ;
  std::cout << "--- Emitting sig1 #9...\n" ;
  sig1->emit("e9_0", "e9_1", "e9_2", "e9_3", "e9_4", "e9_5", "e9_6") ;
  std::cout << "--- Emitting sig1 #10 with accumulator...\n" ;
  accum.str = "" ;
  sig1->emit(accum, "e10_0", "e10_1", "e10_2", "e10_3", "e10_4", "e10_5", "e10_6") ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig2 #11...\n" ;
  sig2->emit("e11_0", "e11_1", "e11_2", "e11_3", "e11_4", "e11_5", "e11_6") ;
  std::cout << "--- Emitting sig2 #12 with accumulator...\n" ;
  accum.str = "" ;
  sig2->emit(accum, "e12_0", "e12_1", "e12_2", "e12_3", "e12_4", "e12_5", "e12_6") ;
  std::cout << "accum.str = " << accum.str << "\n" ;

  std::cout << "--- Deleting c1...\n" ;
  delete c1 ;
  c1 = 0 ;
  std::cout << "--- Emitting sig1 #13...\n" ;
  sig1->emit("e13_0", "e13_1", "e13_2", "e13_3", "e13_4", "e13_5", "e13_6") ;
  std::cout << "--- Emitting sig1 #14 with accumulator...\n" ;
  accum.str = "" ;
  sig1->emit(accum, "e14_0", "e14_1", "e14_2", "e14_3", "e14_4", "e14_5", "e14_6") ;
  std::cout << "accum.str = " << accum.str << "\n" ;
  std::cout << "--- Emitting sig2 #15...\n" ;
  sig2->emit("e15_0", "e15_1", "e15_2", "e15_3", "e15_4", "e15_5", "e15_6") ;
  std::cout << "--- Emitting sig2 #16 with accumulator...\n" ;
  accum.str = "" ;
  sig2->emit(accum, "e16_0", "e16_1", "e16_2", "e16_3", "e16_4", "e16_5", "e16_6") ;
  std::cout << "accum.str = " << accum.str << "\n" ;

  std::cout << "--- Deleting sig1...\n" ;
  delete sig1 ;
  sig1 = 0 ;
  std::cout << "--- Emitting sig2 #17...\n" ;
  sig2->emit("e17_0", "e17_1", "e17_2", "e17_3", "e17_4", "e17_5", "e17_6") ;
  std::cout << "--- Emitting sig2 #18 with accumulator...\n" ;
  accum.str = "" ;
  sig2->emit(accum, "e18_0", "e18_1", "e18_2", "e18_3", "e18_4", "e18_5", "e18_6") ;
  std::cout << "accum.str = " << accum.str << "\n" ;

  std::cout << "--- Deleting c2...\n" ;
  delete c2 ;
  std::cout << "--- Emitting sig2 #19...\n" ;
  sig2->emit("e19_0", "e19_1", "e19_2", "e19_3", "e19_4", "e19_5", "e19_6") ;
  std::cout << "--- Emitting sig2 #20 with accumulator...\n" ;
  accum.str = "" ;
  sig2->emit(accum, "e20_0", "e20_1", "e20_2", "e20_3", "e20_4", "e20_5", "e20_6") ;
  std::cout << "accum.str = " << accum.str << "\n" ;

  std::cout << "--- Deleting sig2...\n" ;
  delete sig2 ;

  std::cout << "--- Test program END ----\n" ;
  return 0 ;
}
